cache:
  paths:
    - .m2/repository

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository"

stages:
  - test
  - visualize
  - package
  - deploy

test:
  image: maven:3.3.9-jdk-8
  stage: test
  script:
    - mvn clean org.jacoco:jacoco-maven-plugin:prepare-agent test jacoco:report
    - cat target/site/jacoco/index.html
  artifacts:
    paths:
      - target/site/jacoco/jacoco.xml
    reports:
      junit:
        - target/surefire-reports/TEST-*.xml
        - target/failsafe-reports/TEST-*.xml

coverage:
  stage: visualize
  image: registry.gitlab.com/haynes/jacoco2cobertura:1.0.7
  script:
    - python /opt/cover2cover.py target/site/jacoco/jacoco.xml $CI_PROJECT_DIR/src/main/java/ > target/site/cobertura.xml
  artifacts:
    reports:
      cobertura: target/site/cobertura.xml

package:
  image: maven:3.3.9-jdk-8
  stage: package
  script:
    - mvn -DskipTests package
  artifacts:
    paths:
      - 'target/perversionresources-*.jar'

deploy_maven:
  image: maven
  stage: deploy
  only:
    - main
  script:
    - mvn -DskipTests deploy -s ci_settings.xml
